///////////////////////////////////////////////////////////////////////////////
// Name:        nkern_net.cpp
// Purpose:     nkernel network code
// Author:      Chad Rempp
// Modified by: Chad Rempp
// Created:     03-01-02
// Copyright:   (c) 2003 Chad Rempp
// Licence:     GNU Public License (hey it's what all my friends are doing)
///////////////////////////////////////////////////////////////////////////////

#include "nkernel/nkern_net.h"

// *****HACK***** I took this out because it was causing problems for the moment
//extern SimData_typ g_SimData;

///////////////////////////////////////////////////////////////////////////////
// Net class Implementation
///////////////////////////////////////////////////////////////////////////////

////////////Net Constructor////////////////////////////////////////////////////
Net::Net(){
                   m_NumInputs          = 2; //g_SimData.NumInputs;
                   m_NumOutputs         = 2; //g_SimData.NumOutputs;
                   m_NumHiddenLayers    = 2; //g_SimData.NumHiddenLayers;
                   m_NumNeuronsPerLayer = 3; //g_SimData.NeuronsPerHLayer;

                   CreateNet();

}

////////////Net Constructor////////////////////////////////////////////////////
Net::Net( int NumInputs,
                  int NumOutputs,
                  int NumHiddenLayers,
                  int NumNeuronsPerLayer) : m_NumInputs(NumInputs),
                                            m_NumOutputs(NumOutputs),
                                            m_NumHiddenLayers(NumHiddenLayers),
                                            m_NumNeuronsPerLayer(NumNeuronsPerLayer)

{
     CreateNet();
}

////////////Net CreateNet Method///////////////////////////////////////////////
void Net::CreateNet(){
     m_vecLayers.push_back(NeuronLayer(m_NumNeuronsPerLayer, m_NumInputs));
     if (m_NumHiddenLayers > 1){
        for (int i=0; i<m_NumHiddenLayers-1; i++)
            m_vecLayers.push_back(NeuronLayer(m_NumNeuronsPerLayer, m_NumNeuronsPerLayer));
     }

     m_vecLayers.push_back(NeuronLayer(m_NumOutputs, m_NumNeuronsPerLayer));

}

////////////Net ModNet Method//////////////////////////////////////////////////
void Net::ModNet(int inputs, int outputs, int hiddenl, int hiddennodes){
	m_NumInputs          = inputs; 
    m_NumOutputs         = outputs; 
    m_NumHiddenLayers    = hiddenl;
	m_NumNeuronsPerLayer = hiddennodes;
}

////////////Net GetWeights Method//////////////////////////////////////////////
vector<float> Net::GetWeights(){
     vector<float> weights;
     for (int i=0; i<m_NumHiddenLayers + 1; i++){
         for (int j=0; j<m_vecLayers[j].m_NumNeurons; j++){
             for (int k=0; k<m_vecLayers[i].m_vecNeurons[j].m_NumInputs; k++){
                 weights.push_back(m_vecLayers[i].m_vecNeurons[j].m_vecWeight[k]);
             }
         }
     }
     return weights;
}

////////////Net PutWeights Method//////////////////////////////////////////////
void Net::PutWeights(vector<float> weights){
     int cWeight = 0;
         for (int i=0; i<m_NumHiddenLayers + 1; i++){
             for (int j=0; j<m_vecLayers[i].m_NumNeurons; j++){
                 for (int k=0; k<m_vecLayers[i].m_vecNeurons[j].m_NumInputs; k++){
                     m_vecLayers[i].m_vecNeurons[j].m_vecWeight[k] = weights[cWeight++];
                 }
             }
         }
     return;
}

////////////Net GetNumberOfWeights Method//////////////////////////////////////
int Net::GetNumberOfWeights(){
    int weights = 0;
    for (int i=0; i<m_NumHiddenLayers +1; i++){
        for (int j=0; j<m_vecLayers[i].m_NumNeurons; j++){
            for (int k=0; k<m_vecLayers[i].m_vecNeurons[j].m_NumInputs; k++)
                weights++;
        }
    }
    return weights;
}

////////////Net Update Method//////////////////////////////////////////////////
vector<float> Net::Update(vector<float> inputs){
   vector<float> outputs;
   int cWeight = 0;

   if (int(inputs.size()) != m_NumInputs)
      return outputs;

   for (int i=0; i<m_NumHiddenLayers +1; i++){
       if ( i > 0 )
          inputs = outputs;

       outputs.clear();

       cWeight = 0;

       for (int j=0; j<m_vecLayers[i].m_NumNeurons; j++){
           float netinput = 0.0f;
           int NumInputs = m_vecLayers[i].m_vecNeurons[j].m_NumInputs;

           for (int k=0; k<NumInputs - 1; k++){
               netinput += m_vecLayers[i].m_vecNeurons[j].m_vecWeight[k] * inputs[cWeight++];
           }

           netinput += m_vecLayers[i].m_vecNeurons[j].m_vecWeight[NumInputs-1] * BIAS;

           outputs.push_back(Sigmoid (netinput, ACTIVATION_RESPONSE));

           cWeight = 0;

       }
   }
   return outputs;
}

////////////Net Sigmoid Method////////////////////////////////////////////////
float Net::Sigmoid(float netinput, float response){
      return (1 / ( 1 + exp(-netinput / response)));
}
