///////////////////////////////////////////////////////////////////////////////
// Name:        nkern_neuron.cpp
// Purpose:     nkernel neuron code
// Author:      Chad Rempp
// Modified by: Chad Rempp
// Created:     03-01-02
// Copyright:   (c) 2003 Chad Rempp
// Licence:     GNU Public License (hey it's what all my friends are doing)
///////////////////////////////////////////////////////////////////////////////

#include "nkernel/nkern_neuron.h"

extern SimData_typ g_SimData;

///////////////////////////////////////////////////////////////////////////////
// Neuron structure Implementation
///////////////////////////////////////////////////////////////////////////////

////////////Neuron Constructor/////////////////////////////////////////////////
Neuron::Neuron(int NumInputs): m_NumInputs(NumInputs+1){

	//we need an additional weight for the bias hence the +1
	for (int i=0; i<NumInputs+1; i++){
		m_vecWeight.push_back(RANDOM_CLAMP);
    }
}

///////////////////////////////////////////////////////////////////////////////
// NeuronLayer structure Implematation
///////////////////////////////////////////////////////////////////////////////

////////////NeuronLayer Constructor////////////////////////////////////////////
NeuronLayer::NeuronLayer(int NumNeurons, 
						   int NumInputsPerNeuron):	m_NumNeurons(NumNeurons), 
													m_NumInputsPerNeuron(NumInputsPerNeuron)
{
	for (int i=0; i<NumNeurons; i++)

		m_vecNeurons.push_back(Neuron(NumInputsPerNeuron));
}


