///////////////////////////////////////////////////////////////////////////////
// Name:        nviz3d.h
// Purpose:     3D Visualization Header
// Author:      Chad Rempp
// Modified by: Chad Rempp
// Created:     06-01-03
// Copyright:   (c) Chad Rempp 2003
// Licence:     GNU Public License
///////////////////////////////////////////////////////////////////////////////

#ifndef _NVIZ3D_H_
#define _NVIZ3D_H_

#include "wx/wx.h"
#include "wx/glcanvas.h"
#include "GL/glu.h"

///////////////////////////////////////////////////////////////////////////////
//  NVizFrame class Definition
///////////////////////////////////////////////////////////////////////////////
class Nviz3DCanvas;
class NvizFrame: public wxFrame
{
public:
    NvizFrame(wxDialog *parent, const wxString& title, const wxPoint& pos,
              const wxSize& size, long style = wxDEFAULT_FRAME_STYLE);
    void OnExit(wxCommandEvent& event);
    
public:
    Nviz3DCanvas*    glc_nvizcanvas;

DECLARE_EVENT_TABLE()
};

///////////////////////////////////////////////////////////////////////////////
//  NViz3DCanvas class Definition
///////////////////////////////////////////////////////////////////////////////
class Nviz3DCanvas: public wxGLCanvas
{
  friend class NVizFrame;
public:
    Nviz3DCanvas(wxWindow *parent, const wxWindowID id = -1,
                 const wxPoint& pos = wxDefaultPosition,
                 const wxSize& size = wxDefaultSize,
                 long style = 0, const wxString& name = "TestGLCanvas");
    ~Nviz3DCanvas(void);
    void DrawNeuron(GLUquadricObj *obj, GLfloat x, GLfloat y, GLfloat z);
    void InitGL(void);
    void OnEnterWindow( wxMouseEvent& event );
    void OnEraseBackground(wxEraseEvent& event);
    void OnMouse( wxMouseEvent& event );
    void OnPaint(wxPaintEvent& event);
    void OnSize(wxSizeEvent& event);
    void Render( void );

private:
    bool   m_init;

DECLARE_EVENT_TABLE()
};

#endif

